<?php

class og_subgroups_views_handler_sort_hierarchy extends views_handler_sort {
  /**
   * The sort cannot be exposed
   */
  function can_expose() { return FALSE; }

  function query() {
    og_subgroups_include('tree');
    $tree = og_subgroups_get_tree();
    $gids = array();

    // The order in which the tree is built
    // is the order that the group nodes should be displayed.
    foreach($tree as $parent) {
      // add the parent to the beginning of the list
      $lineage[$parent->nid] = $parent;
      $lineage += og_subgroups_get_group_children($parent, FALSE);
      
      foreach ($lineage as $gid => $group) {
        $gids[$gid] = $gid;
      }
    }
    
    // remove duplicates
    $gids = array_unique($gids);

    if (!empty($gids)) {
      $sort_order = implode(',', $gids);
      $base_table = $this->query->base_table;
      $base_field = $this->query->base_field;
      $formula = "FIELD($base_table.$base_field, $sort_order)";

      $this->query->add_orderby(NULL, $formula, $this->options['order'], '_' . $this->field);
    }
  }
}